from toAlfred import alfred
import re

class alfredWrap(alfred):

	# filter: filter the query results, and it's default value is false.
	# searchKey: query keyword, it's default value is false, and must be contrary to the filter.
	def __init__(self,items=None,total=True,cache=True,key=False,filter=True,params=''):
		super(alfredWrap, self).__init__(items,total,cache,key,filter)
		self.__searchKey = not filter
		self.__params = params
		self.__waitingWord = 'Waiting for the parameter input ;'
		self.__indexExceptionString = 'The index beyond the length of the list.'
		self.__emptyExceptionString = 'element empty.'

		self.__url = ''
		self.__listRule = ''
		self.__title = ''
		self.__subtitle = ''
		self.__href = ''
		self.__icon = ''

	# titile,subtitle,href ==> ['rule',index,'ruleType=css|label','textType='text|attribute']
	def setConfig(self,url,listRule,title,subtitle='',href='',icon='',totalRule=None, istile=False, tileListRule=''):
		self.__url = url
		self.__listRule = listRule
		self.__title = title
		self.__subtitle = subtitle
		self.__href = href
		self.__icon = icon
		self.__totalRule = totalRule
		self.__istile = istile # search list whether or not tiled
		self.__tileListRule = tileListRule # just for get tile list
		return self

	def checkConfig(self):
		checkWord = None
		if not (self.__url and type(self.__url) == str):
			checkWord = 'please set valid string type for your links.'
		elif not (self.__listRule and (type(self.__listRule) == dict or type(self.__listRule) == list)):
			checkWord = 'please set valid dict type to the rules for your list.'
		elif not (self.__title and type(self.__title) == list and len(self.__title)==4):
			checkWord = 'please set valid list type to the title of feedback'
		elif self.__subtitle and not (type(self.__subtitle) == list and len(self.__subtitle)==4):
			checkWord = 'please set valid list type to the subtitle of feedback'
		elif self.__href and not (type(self.__href) == list and len(self.__href)==4):
			checkWord = 'please set valid list type to the href of feedback'
		elif self.__icon and not type(self.__icon) == str:
			checkWord = 'please set valid string type to the icon of feedback'
		elif self.__totalRule and not type(self.__totalRule) == list:
			checkWord = 'please set valid list type to the totalRule for your list'


		if checkWord:
			self.__waitingWord = checkWord
			return False
		else:
			return True

	def getList(self,item,rule):
		if not (item):
			self.__waitingWord = 'please check your network'
			return False
		else:
			_type = type(rule)
			if _type == dict:
				return item.find_all(**rule)
			elif _type == list:
				methodName = 'find_all'
				if rule[1] == 'css':
					methodName = 'select'
				_method = getattr(item,methodName)
				return _method(rule[0])


	def getValue(self,item,list, defaultIndex=None):
		if not (item and list):
			return ''
		else:
			rule = list[0]
			index = list[1]
			ruleType = list[2]
			textType = list[3]

			e = None
			value = ''
			methodName = 'find_all'
			if ruleType == 'css':
				methodName = 'select'
			_method = getattr(item,methodName)
			if type(rule) == tuple:
				for i in rule:
					e = _method(i)
					if len(e)!=0:
						break
			else:
				e = _method(rule)
			length = len(e)
			if length ==0:
				return self.__emptyExceptionString
			elif length < index + 1 and not self.__istile:
				return self.__indexExceptionString
			e = e[defaultIndex if self.__istile else index]

			if textType == 'text':
				value = e.get_text()
			else:
				value = e.get(textType)
			value = re.sub(r'\s{2,}', ' ', value)
			return value.replace('\n','').strip()

	def getItems(self):
		if not self.checkConfig():
			return [[self.__waitingWord]]
		if self.__searchKey:
			q = self.getParam(1)
			if q==None or q.find(';')<0:
				return [[self.__waitingWord, '', '', self.__icon]]
			q = q.replace(';','')
			self.__url = self.__url.replace('{searchKey}',q)

		# get html
		soups = self.getSoup(self.__url,self.__listRule)
		soup4html = soups[0]
		soup4list = soups[1]

		items = []
		# set total message
		if self.__totalRule:
			totalInfo = self.getValue(soup4html,self.__totalRule).replace(' ','')
			items.append([totalInfo,'','',self.__icon])

		# set list message
		if self.__istile:
			item = soup4list[0]
			list = item.find_all(self.__tileListRule)
			for i in range(len(list)):
				title = self.getValue(item,self.__title, i)
				subtitle = self.getValue(item,self.__subtitle, i)
				href = self.getValue(item,self.__href, i)
				items.append([title, subtitle, href, self.__icon])
		else:
			for item in soup4list:
				title = self.getValue(item,self.__title)
				subtitle = self.getValue(item,self.__subtitle)
				href = self.getValue(item,self.__href)
				items.append([title, subtitle, href, self.__icon])
		return items

	def getSoup(self,url,rule):
		import urllib2
		from bs4 import BeautifulSoup
		# opener = urllib2.build_opener()
		# page = opener.open(url)
		hdr = {'User-Agent': 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.11 (KHTML, like Gecko) Chrome/23.0.1271.64 Safari/537.11',
       		   'Accept': 'text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8',
       		   'Accept-Charset': 'ISO-8859-1,utf-8;q=0.7,*;q=0.3',
       		   'Accept-Encoding': 'none',
       		   'Accept-Language': 'en-US,en;q=0.8',
       	   	   'Connection': 'keep-alive'}

		req = urllib2.Request(url, headers=hdr)
		try:
			page = urllib2.urlopen(req)
			data = page.read()
			soup = BeautifulSoup(data)
			return [soup,self.getList(soup,rule)]
		except urllib2.HTTPError, e:
		    print e.fp.read()
	
	def getParamArray(self):
		return self.getParamString().split(' ')

	def getParamString(self,cursor=0):
		if self.__params:
			# invalid
			# import urllib
			# params = urllib.quote(self.__params)
			return self.__params
		else:
			sys = self.supportChinese()
			params = ' '.join(sys.argv).strip()

		# TODO
		content = params

		return content

	def getParam(self,cursor=0):
		# If self.__params specified, then the space is no longer used as a delimiter, the parameters will be returned directly.
		if self.__params:
			return self.__params
		params = self.getParamArray()
		if len(params)>cursor:
			return params[cursor]

	def supportChinese(self):
		import sys
		reload(sys)
		sys.setdefaultencoding('utf-8')
		return sys

	def init(self):
		if self.getFilter():
			sys = self.supportChinese()
			self.setInputFilter(None) if len(sys.argv)==1 else self.setInputFilter(self.getParam(1))# filter
		self.getOutput()
		return self

	# def __call__(self):
	# 	self.init()