import alfred2
import feedback
_feedback = feedback.Feedback()

class alfred(object):
	# title, subtitle="", arg="", icon="icon.png" , valid="yes", autocomplete="",uid=""
	def __init__(self,items=None,total=True,cache=True,key=False,filter=True):
		self.__items = items
		self.__needCache = cache
		self.__needTotalInfo = total

		self.__key = None
		self.__informalKey = key
		self.__keyPrefix = 'workflow.list.'

		self.__filter = filter
		self.__inputFilter = None

	def getItems(self):
		return None

	def setItems(self,items):
		self.__items = items

	def getTotal(self):
		return self.__needTotalInfo

	def setTotal(self,total):
		self.__needTotalInfo = total

	def getCache(self):
		return self.__needCache

	def setCache(self,cache):
		self.__needCache = cache

	def getFilter(self):
		return self.__filter

	def setFilter(self,filter):
		self.__filter = filter

	def getInputFilter(self):
		return self.__inputFilter

	def setInputFilter(self,inputFilter):
		self.__inputFilter = inputFilter

	def getOutput(self):
		cache = self.getAlfredCache()
		if not cache:
			cache = self.setAlfredCache()
		#do something for filter
		if self.__filter and self.__inputFilter:
			cache = [i for i in cache if i[0].lower().find(self.__inputFilter.lower())>=0]
			self.setItems(cache)
		self.output()

	def output(self,items=None):
		if not items:
			items = self.__items
		if not items:
			return False
		if self.__needTotalInfo:
			_feedback.add_item(u'\u5171\u6709 '+str(len(items))+u' \u9879','','','statistic_32.png')
		if type(items) is list:
			for item in items:
				if type(item) is list:
					_feedback.add_item(*item)
				else:
					_feedback.add_item(item)
		#TODO export csv file
		#
		print _feedback

	# def outputSimple(self,items=None):
	# 	self.output(items,False)

	# if key==None, then has keyPrefix, else no keyPrefix
	def setAlfredCache(self,items=None,key=None):
		if not items:
			if self.__items:
				items = self.__items
			else:
				items = self.getItems()
		if self.__needCache:# or alfred2.cache.timeout(key) == -1:
			key = self.getKey(key)
			alfred2.cache.set(key, items, expire=60*60*24*365)
		self.__items = items
		return items

	# if key==None, then has keyPrefix, else no keyPrefix
	def getAlfredCache(self,items=None,key=None):
		if not self.__items and self.__needCache:
			key = self.getKey(key)
			self.__items = alfred2.cache.get(key)
		return self.__items

	def setKey(self,key):
		self.__informalKey = key

	def getKey(self,item):
		if not item:
			if self.__key:
				return self.__key
			elif self.__informalKey:
				item = self.__informalKey
			else:
				import sys
				import os
				item = os.path.basename(sys.argv[0]).replace('.py','')
			item = self.__keyPrefix + item
			self.__key = item
		return item